/*
 *  Font 12x12 -- WiFiBoy32 Demo Code for Arduino/ESP32
 *
 *  Oct 13, 2017 Created. (derek@wifiboy.org)
 */
#include "wifiboy32.h"
#include "wbFontB12.h"

uint8_t bits[]={0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
uint16_t _cx, _cy, i, j, count;
uint16_t _color1, _color2;

void showbits(uint8_t c, uint8_t n)
{
  for(int i=0; i<4; i++, _cx++) 
    if (c & bits[i+n]) wb32_drawPixel(_cx, _cy, _color1);
    else wb32_drawPixel(_cx, _cy, 0); 
}

void dispfont(uint16_t n)
{
  count = 0;
  for(int i=0; i<18; i++) {
    showbits((uint8_t)(b5f12[n*18+i]), 0);
    if (++count % 3 == 0) { _cx-=12; _cy++; } 
    showbits((uint8_t)(b5f12[n*18+i]), 4);
    if (++count % 3 == 0) { _cx-=12; _cy++; } 
  }
}

void setup() {
  wb32_init();
  wb32_fillScreen(wbBLACK);
}

void loop() {
  _cx=(rand()%16)*15;
  _cy=(rand()%20)*16;
  _color1=(rand()%65536)|0x8410;
  dispfont(rand()%5401);
}
